OH323_SRCDIR = $(OPENH323DIR)/src
OH323_INCDIR = $(OPENH323DIR)/include
OH323_LIBDIR = $(OPENH323DIR)/lib
OH323_OBJDIR = $(OH323_LIBDIR)/$(PT_OBJBASE)

OH323_BASE  = h323_$(PLATFORM_TYPE)_$(OBJ_SUFFIX)
OH323_FILE  = lib$(OH323_BASE)$(LIB_TYPE).$(LIB_SUFFIX)

LDFLAGS	    += -L$(OH323_LIBDIR)
LDLIBS	    := -l$(OH323_BASE)$(LIB_TYPE) $(LDLIBS)

#OH323_SUPPRESS_H235	= 1

STDCCFLAGS  += -I$(OH323_INCDIR)

ifdef	OH323_SUPPRESS_H235
STDCCFLAGS  += -DOH323_SUPPRESS_H235
endif

ifneq (,$(wildcard /usr/X11R6/include/X11/X.h))
HAS_X11	    = 1
STDCCFLAGS  += -DHAS_X11
endif

ifneq (,$(wildcard /usr/include/linux/telephony.h))
HAS_IXJ	    = 1
STDCCFLAGS += -DHAS_IXJ
endif

ifneq (,$(wildcard /usr/include/linux/soundcard.h))
HAS_OSS	    = 1
STDCCFLAGS += -DHAS_OSS
endif

ifeq ($(OSTYPE),linux)

#ifneq (,$(wildcard /usr/local/lib/libvpb.a))
#HAS_VPB	   = 1
#STDCCFLAGS += -DHAS_VPB
#LDLIBS	   += /usr/local/lib/libvpb.a
#endif

# linux
endif

ifdef NOTRACE
STDCCFLAGS += -DPASN_NOPRINTON -DPASN_LEANANDMEAN
else
STDCCFLAGS += -DPTRACING
RCFLAGS	   += -DPTRACING
endif

$(OBJS) :	$(OH323_LIBDIR)/$(OH323_FILE)

ifndef OD323_LIBRARY_MAKEFILE
ifdef DEBUG
$(OH323_LIBDIR)/$(OH323_FILE):
	$(MAKE) -C $(OH323_SRCDIR) debug
else
$(OH323_LIBDIR)/$(OH323_FILE):
	$(MAKE) -C $(OH323_SRCDIR) opt
endif
endif

