/*
 * ixjdummy.cxx
 *
 * QuickNet Internet Phone/Line JACK codec interface
 *
 * Open H323 Library
 *
 * Copyright (c) 2000 Equivalence Pty. Ltd.
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.0 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.
 *
 * The Original Code is Open H323 Library.
 *
 * The Initial Developer of the Original Code is Equivalence Pty. Ltd.
 *
 * Portions of this code were written with the assisance of funding from 
 * Quicknet Technologies, Inc. http://www.quicknet.net.
 * 
 * Contributor(s): ______________________________________.
 *
 * $Log: ixjdummy.cxx,v $
 * Revision 1.2  2000/05/25 04:36:37  robertj
 * Added get of volume levels
 *
 * Revision 1.1  2000/05/15 13:50:09  robertj
 * Added dummy code for Quicknet xJack interface on platforms that do not yet have drivers.
 *
 */

#include <ptlib.h>
#include "ixjlid.h"


#define new PNEW



/////////////////////////////////////////////////////////////////////////////

OpalIxJDevice::OpalIxJDevice()
{
  os_handle = -1;
  readStopped = writeStopped = TRUE;
  readFrameSize = writeFrameSize = 480;  // 30 milliseconds of 16 bit PCM data
  aecLevel = AECOff;
}


BOOL OpalIxJDevice::Open(const PString &)
{
  return FALSE;
}


BOOL OpalIxJDevice::Close()
{
  return FALSE;;
}


PString OpalIxJDevice::GetName() const
{
  return "xJACK";
}

unsigned OpalIxJDevice::GetLineCount()
{
  return 0;
}

BOOL OpalIxJDevice::IsLinePresent(unsigned)
{
  return FALSE;
}


BOOL OpalIxJDevice::IsLineOffHook(unsigned)
{
  return FALSE;
}


BOOL OpalIxJDevice::SetLineOffHook(unsigned, BOOL)
{
  return FALSE;
}


BOOL OpalIxJDevice::IsLineRinging(unsigned, DWORD *)
{
  return FALSE;
}


BOOL OpalIxJDevice::RingLine(unsigned, DWORD)
{
  return FALSE;
}


BOOL OpalIxJDevice::IsLineDisconnected(unsigned)
{
  return FALSE;
}


BOOL OpalIxJDevice::SetLineToLineDirect(unsigned, unsigned, BOOL)
{
  return FALSE;
}


BOOL OpalIxJDevice::IsLineToLineDirect(unsigned, unsigned)
{
  return FALSE;
}


PIntArray OpalIxJDevice::GetPayloadTypes() const
{
  PIntArray codecs;

  return codecs;
}


BOOL OpalIxJDevice::SetReadCodec(unsigned, RTP_DataFrame::PayloadTypes)
{
  return FALSE;
}

BOOL OpalIxJDevice::SetWriteCodec(unsigned, RTP_DataFrame::PayloadTypes)
{
  return FALSE;
}


BOOL OpalIxJDevice::StopReadCodec(unsigned)
{
  return FALSE;
}


BOOL OpalIxJDevice::StopWriteCodec(unsigned)
{
  return FALSE;
}


PINDEX OpalIxJDevice::GetReadFrameSize(unsigned)
{
  return readFrameSize;
}


PINDEX OpalIxJDevice::GetWriteFrameSize(unsigned)
{
  return writeFrameSize;
}


BOOL OpalIxJDevice::ReadFrame(unsigned, void *)
{
  return FALSE;
}

BOOL OpalIxJDevice::WriteFrame(unsigned, const void *)
{
  return FALSE;
}


unsigned OpalIxJDevice::GetAverageSignalLevel(unsigned)
{
  return FALSE;
}


BOOL OpalIxJDevice::EnableAudio(unsigned line, BOOL)
{
  return FALSE;
}


BOOL OpalIxJDevice::SetRecordVolume(unsigned, unsigned)
{
  return FALSE;
}


BOOL OpalIxJDevice::SetPlayVolume(unsigned, unsigned)
{
  return FALSE;
}


BOOL OpalIxJDevice::GetRecordVolume(unsigned, unsigned &)
{
  return FALSE;
}


BOOL OpalIxJDevice::GetPlayVolume(unsigned, unsigned &)
{
  return FALSE;
}


OpalLineInterfaceDevice::AECLevels OpalIxJDevice::GetAEC(unsigned)
{
  return aecLevel;
}


BOOL OpalIxJDevice::SetAEC(unsigned, AECLevels level)
{
  aecLevel = level;
  return FALSE;
}


BOOL OpalIxJDevice::GetCallerID(unsigned, PString &, BOOL)
{
  return FALSE;
}


BOOL OpalIxJDevice::SetCallerID(unsigned, const PString &)
{
  return FALSE;
}


BOOL OpalIxJDevice::PlayDTMF(unsigned, const char *, DWORD, DWORD)
{
  return FALSE;
}


char OpalIxJDevice::ReadDTMF(unsigned)
{
  return '\0';
}


BOOL OpalIxJDevice::GetRemoveDTMF(unsigned)
{
  return FALSE;
}


BOOL OpalIxJDevice::SetRemoveDTMF(unsigned, BOOL)
{
  return FALSE;
}


OpalLineInterfaceDevice::CallProgressTones OpalIxJDevice::IsToneDetected(unsigned)
{
  return NumTones;
}


BOOL OpalIxJDevice::PlayTone(unsigned, CallProgressTones)
{
  return FALSE;
}


BOOL OpalIxJDevice::IsTonePlaying(unsigned)
{
  return FALSE;
}


BOOL OpalIxJDevice::StopTone(unsigned)
{
  return FALSE;
}


BOOL OpalIxJDevice::SetCountryCode(T35CountryCodes)
{
  return FALSE;
}


PStringArray OpalIxJDevice::GetDeviceNames()
{
  PStringArray array;

  return array;
}


/////////////////////////////////////////////////////////////////////////////
