/* =========================================================================
   grabber-bsd.h     Grabber code for the Matrox Meteor API
                     and BSD bktr Bt848/878 driver.
                     Copyright (c) 2000 Roger Hardiman <roger@freebsd.org>
   =========================================================================
*/

#include <ptlib.h>

#ifndef GRABBER_BSD_H
#define GRABBER_BSD_H

#include "grabber.h"
#include "videoframe.h"

class VideoGrabber : public Grabber {
public:
    VideoGrabber(int videoInput, BOOL videoIsPal);
    virtual   ~VideoGrabber();

    virtual   void Start();
    virtual   void Stop();
    virtual   void Grab(VideoFrame *vf);
    virtual   void SetSize(int _width,int _height);

protected:
    void Format();

    int fd_;         //file descriptor for video device.
    int port_;       //input ports for grabbers with more than one
                     //capture port. Port 0 - RCA Compsite Input.
    BOOL pal_;       //TRUE is use PAL video. FALSE is use NTSC video;
};

#endif    //ifndef GRABBER_BSD_H

