/*grabber.linux.h     Derek J Smithies (derek@indranet.co.nz)
 *                    Indranet Technologies ltd (lara@indranet.co.nz)
 *
 */
#include <ptlib.h>

#ifndef GRABBER_LINUX_H
#define GRABBER_LINUX_H
extern "C" {
#include <asm/types.h>
#include "linux/videodev.h"
}



#include "grabber.h"
#include "videoframe.h"


class VideoGrabber : public Grabber {
public:
    VideoGrabber(int videoInput, BOOL videoIsPal);
    virtual   ~VideoGrabber();

    virtual   void Start();
    virtual   void Stop();
    virtual   void Grab(VideoFrame *vf);
    virtual   void SetSize(int _width,int _height);

protected:
    void Format();
    struct video_capability  capability;
    struct video_channel     *card_channels; //info on installed video card 
    struct video_picture     pict;

    /* mmap */
    int                      sync_count;
    struct video_mmap        gb_even;
    struct video_mmap        gb_odd;
    struct video_mbuf        gb_buffers;

    int fd_;         //file descriptor for video device.
    int format_;     //format as in videodev.h
    int port_;
};


#endif    //ifndef GRABBER_LINUX_H
