/*grabber-windows.h     Derek J Smithies (derek@indranet.co.nz)
 *                      Indranet Technologies ltd (lara@indranet.co.nz)
 *
 */
#include <ptlib.h>

#ifndef GRABBER_WINDOWS_H
#define GRABBER_WINDOWS_H


#include "grabber.h"
#include "videoframe.h"


class VideoGrabber : public Grabber {
public:
    VideoGrabber(int videoInput, BOOL videoIsPal);
    virtual   ~VideoGrabber();

    virtual   void Start();
    virtual   void Stop();
    virtual   void Grab(VideoFrame *vf);
    virtual   void SetSize(int _width,int _height);

protected:
    void Format();

    /* mmap */
    int                      grab_count;
    int                      sync_count;

    int fd_;         //file descriptor for video device.
    int format_;     //format as in videodev.h
    int port_;
};


#endif    //ifndef GRABBER_WINDOWS_H
