/*
*########################################################################
*########################################################################
*########################################################################
*                                                               
*   COPYRIGHT (c) 1998, 1999, 2000 by TransNexus, LLC                          
*                                                                    
*   This software contains proprietary and confidential information  
*   of TransNexus, LLC. Except as may be set forth in the license    
*   agreement under which this software is supplied, use, disclosure, 
*   or reproduction is prohibited without the prior, express, written
*   consent of TransNexus, LLC.                                      
*                                     
*
*
*
*
*
*
*#########################################################################
*#########################################################################
*#########################################################################
*/
#include "ospasn1.h"

/*************************************************************************
 * Structure definitions:
 *************************************************************************/

/*
 * This structure should be constructed so that it adequately describes
 * any parameters that may be taken from the command line. Other structures
 * can be used to describe the type of operation being performed by the
 * enrollment client. 
 */
typedef struct _OSPTENROLLPARAMS 
{
    unsigned char*  Function;
    unsigned char*  Username;
    unsigned char*  Password;
    unsigned char*  DeviceId;
    unsigned char*  CustomerId;
    unsigned char*  Nonce;
    unsigned        NonceLen;
    unsigned char*  CertReq;
    unsigned char*  Subject;
    unsigned char*  SSLUrl;
    unsigned char*  CAUrl;
    unsigned char*  CAFprint;
    unsigned char*  CACert;
    unsigned        CACertLen;
    unsigned char*  CACertB64;
    unsigned        CACertB64Len;
    unsigned        Verbose;
} OSPTENROLLPARAMS;

/* 
 * This is for specifying what to use for the communication manager's
 * parameters. This will have to be set from outside the enrollment client,
 * preferably in some manner that also suits the OSP SDK. This list may
 * expand or contract, but it should only be used by the functions for
 * collecting this data and for the function that initializes the 
 * communications manager. After that, this list will not be used anywhere
 * else, so changes to function prototypes, variables, and so
 * on should be contained to the functions using this structure.
 *
 * The authority's certificates are included here for validating any
 * information ( e.g., certificates ) that come back.
 */
typedef struct _OSPTCOMMPARAMS
{
    unsigned    SSLLifetime;    
    unsigned    HTTPMaxConnections;
    unsigned    HTTPPersistence;
    unsigned    HTTPRetryDelay;
    unsigned    HTTPRetryLimit;
    unsigned    HTTPTimeout;
} OSPTCOMMPARAMS;
