/*
*########################################################################
*########################################################################
*########################################################################
*                                                               
*   COPYRIGHT (c) 1998, 1999 by TransNexus, LLC                          
*                                                                    
*   This software contains proprietary and confidential information  
*   of TransNexus, LLC. Except as may be set forth in the license    
*   agreement under which this software is supplied, use, disclosure, 
*   or reproduction is prohibited without the prior, express, written
*   consent of TransNexus, LLC.                                      
*                                     
*
*
*
*
*
*
*#########################################################################
*#########################################################################
*#########################################################################
*/

/*
 * ospauthcnf.c - OSP authorisation confirmation functions
 */

#include "osp.h"
#include "osperrno.h"
#include "ospbfr.h"
#include "ospxmlattr.h"
#include "ospxmlelem.h"
#include "ospmsgattr.h"
#include "ospmsgelem.h"
#include "ospauthcnf.h"
#include "ospstatus.h"
#include "osputils.h"


/*-----------------------------------------------------------------------*
 * OSPPAuthCnfDelete() - destroy specified AuthCnf object
 *-----------------------------------------------------------------------*/

void
OSPPAuthCnfDelete(
    OSPTAUTHCNF **ospvAuthCnf
)
{

    if (*ospvAuthCnf != OSPC_OSNULL)
    {
        if (OSPPAuthCnfHasStatus(*ospvAuthCnf))
        {
            OSPPStatusDelete(&((*ospvAuthCnf)->ospmAuthCnfStatus));
        }
        OSPM_FREE(*ospvAuthCnf);
        *ospvAuthCnf = OSPC_OSNULL;
    }
}

#ifdef OSPC_DEBUG
/**/
/*-----------------------------------------------------------------------*
 * OSPPAuthCnfHasStatus() - does the authorisation confirmation have
 * a status?
 *-----------------------------------------------------------------------*/

unsigned                            /* returns non-zero if number exists */
OSPPAuthCnfHasStatus(
    OSPTAUTHCNF *ospvAuthCnf       /* authorisation confirmation effected */
)
{
    unsigned ospvHasStatus = OSPC_FALSE;

    if(ospvAuthCnf != OSPC_OSNULL)
    {
        ospvHasStatus = ((ospvAuthCnf)->ospmAuthCnfStatus != OSPC_OSNULL);
    }
    return(ospvHasStatus);
}

#endif /* OSPC_DEBUG */

