/*
*########################################################################
*########################################################################
*########################################################################
*                                                               
*   COPYRIGHT (c) 1998, 1999 by TransNexus, LLC                          
*                                                                    
*   This software contains proprietary and confidential information  
*   of TransNexus, LLC. Except as may be set forth in the license    
*   agreement under which this software is supplied, use, disclosure, 
*   or reproduction is prohibited without the prior, express, written
*   consent of TransNexus, LLC.                                      
*                                     
*
*
*
*
*
*
*#########################################################################
*#########################################################################
*#########################################################################
*/

/*
 * ospauthcnf.h - OSP authorisation confirmation objects
 */

#ifndef _OSPAUTHCNF_H
#define _OSPAUTHCNF_H

#include "osp.h"
#include "ospxmlelem.h"
#include "ospmsg.h"
#include "ospstatus.h"

typedef struct
{
    OSPTTIME          ospmAuthCnfTimestamp;
    OSPTSTATUS       *ospmAuthCnfStatus;
    OSPTTIME          ospmAuthCnfValidAfter;
    OSPTTIME          ospmAuthCnfValidUntil;
}
OSPTAUTHCNF;


/**/
/*-----------------------------------------------------------------------*
 * macros that emulate functions
 *-----------------------------------------------------------------------*/

/*
 * Note: all macros are also implemented as functions in ospauthcnf.c.
 * For implementation details, see the comments in that file. To replace
 * a macro with a true function, simply comment out the macro definition
 * below.
 */
#ifndef OSPC_DEBUG

#define OSPPAuthCnfHasStatus(ospvAuthCnf) \
                (ospvAuthCnf)? \
                ((unsigned)((ospvAuthCnf)->ospmAuthCnfStatus != OSPC_OSNULL)) \
                :OSPC_FALSE

#endif /* OSPC_DEBUG */
/**/
/*-----------------------------------------------------------------------*
 * function prototypes
 *-----------------------------------------------------------------------*/

#ifdef __cplusplus
extern "C"
{
#endif

    void         OSPPAuthCnfDelete(OSPTAUTHCNF **);

#ifdef OSPC_DEBUG

    unsigned     OSPPAuthCnfHasStatus(OSPTAUTHCNF *ospvAuthCnf);

#endif /* OSPC_DEBUG */

#ifdef __cplusplus
}
#endif

#endif /* _OSPAUTHCNF_H */
