/*
*########################################################################
*########################################################################
*########################################################################
*                                                               
*   COPYRIGHT (c) 1998, 1999 by TransNexus, LLC                          
*                                                                    
*   This software contains proprietary and confidential information  
*   of TransNexus, LLC. Except as may be set forth in the license    
*   agreement under which this software is supplied, use, disclosure, 
*   or reproduction is prohibited without the prior, express, written
*   consent of TransNexus, LLC.                                      
*                                     
*
*
*
*
*
*
*#########################################################################
*#########################################################################
*#########################################################################
*/


/*
 * ospcode.h - Status codes and strings for status element
 */
#ifndef _OSPCODE_H
#define _OSPCODE_H


typedef struct statuscode{
    unsigned ospmCode;
    unsigned char *ospmDesc;
}OSPTSTATLIST;

#define MAX_STATS   23

OSPTSTATLIST statlist[23] = {
/*2xx  =  operation successful*/
    {200, "success"},
    {201, "information created"},
    {210, "updated information accepted"},
/*4xx  =  client error*/
    {400, "bad request"},
    {401, "unauthorised"},
    {410, "character encoding not supported"},
    {411, "parsing unsuccessful"},
    {412, "critical element not supported"},
    {420, "generic security problem"},
    {421, "signature invalid"},
    {422, "cryptographic algorithm not supported"},
    {423, "certificate invalid"},
    {424, "certificate revoked"},
    {425, "encryption required"},
/*5xx  =  server error*/
    {500, "internal server error"},
    {501, "not implemented"},
    {503, "service not available},
    {510, "transient problem in server},
    {520, "long term problem in server},
    {530, "time problem"}
    {531, "valid time too soon"},
    {532, "time interval too small"},
    {999, "generic failure"}
    };


#endif
