/*
*########################################################################
*########################################################################
*########################################################################
*                                                               
*   COPYRIGHT (c) 1998, 1999 by TransNexus, LLC                          
*                                                                    
*   This software contains proprietary and confidential information  
*   of TransNexus, LLC. Except as may be set forth in the license    
*   agreement under which this software is supplied, use, disclosure, 
*   or reproduction is prohibited without the prior, express, written
*   consent of TransNexus, LLC.                                      
*                                     
*
*
*
*
*
*
*#########################################################################
*#########################################################################
*#########################################################################
*/

/*
 * ospcrypto.h      Constants and prototypes for OSP crypto library
 *
 */

#ifndef _OSP_CRYPTO_H
#define _OSP_CRYPTO_H

#ifdef __cplusplus
extern "C" 
{
#endif

    /*
     * Member functions
     */

    int
    OSPPCryptoVerify(
        OSPTASN1OBJECT  *ospvSignature,
        OSPTASN1OBJECT  *ospvReaderKey,
        unsigned char   *ospvData,
        unsigned        ospvDataLength);

    int
    OSPPCryptoDigest( 
        OSPTASN1OBJECT  **ospvDigest, 
        OSPTASN1OBJECT  *ospvAlgorithmId,
        unsigned char   *ospvData, 
        unsigned int    ospvDataLength);

    int 
    OSPPCryptoEncrypt(
        OSPTASN1OBJECT  **ospvEncryptedData,
        OSPTASN1OBJECT  *ospvAlgorithmId,
        OSPTASN1OBJECT  *ospvData,
        OSPTASN1OBJECT  *ospvPrivateKeyInfo);

    int 
    OSPPCryptoDecrypt(
        OSPTASN1OBJECT  **ospvDecryptedData,
        OSPTASN1OBJECT  *ospvAlgorithmId,
        OSPTASN1OBJECT  *ospvEncryptedData,
        OSPTASN1OBJECT  *ospvBERReaderKey);
    /*
     * Non-Member functions
     */

#ifdef __cplusplus
}
#endif

#endif
