
/*
*########################################################################
*########################################################################
*########################################################################
*                                                               
*   COPYRIGHT (c) 1998, 1999 by TransNexus, LLC                          
*                                                                    
*   This software contains proprietary and confidential information  
*   of TransNexus, LLC. Except as may be set forth in the license    
*   agreement under which this software is supplied, use, disclosure, 
*   or reproduction is prohibited without the prior, express, written
*   consent of TransNexus, LLC.                                      
*                                     
*
*
*
*
*
*
*#########################################################################
*#########################################################################
*#########################################################################
*/


#define OSPC_CRYPTO_DECRYPT_BUFFER_MAXLENGTH    1024
#define OSPC_CRYPTO_ENCRYPT_BUFFER_MAXLENGTH    1024
#define OSPC_CRYPTO_DIGEST_BUFFER_MAXLENGTH 1024

#define OSPC_CRYPTO_FLAG_NORMAL            0x00             
#define OSPC_CRYPTO_FLAG_USE_BER_ALGORITHM 0x01
#define OSPC_CRYPTO_FLAG_USE_PUBLIC_KEY    0x02
#define OSPC_CRYPTO_FLAG_RAW_MODE          0x04
#define OSPC_CRYPTO_FLAG_USE_SHA1_DIGEST   0x08
#define OSPC_CRYPTO_FLAG_ENCRYPTED_WITH_PUBLIC_KEY 0x10

#ifdef __cplusplus
extern "C" 
{
#endif



    int 
    OSPPCryptoWrapDigest(
            unsigned char   *ospvDigest,
            unsigned        *ospvDigestLength,
            unsigned char   *ospvBERAlgorithm,
            unsigned        ospvBERAlgorithmLength,
            unsigned char   *ospvData,
            unsigned        ospvDataLength,
            unsigned char   ospvFlags);

    int 
    OSPPCryptoWrapEncrypt(
            unsigned char   *ospvEncryptedData,
            unsigned        *ospvEncryptedDataLength,
            unsigned char   *ospvBERAlgorithm,
            unsigned        ospvBERAlgorithmLength,
            unsigned char   *ospvData,
            unsigned        ospvDataLength,
            unsigned char   *ospvSignerKey,
            unsigned        ospvSignerKeyLength,
            unsigned char   ospvFlags);

    int 
    OSPPCryptoWrapDecrypt(
            unsigned char   *ospvDecryptedData,
            unsigned        *ospvDecryptedDataLength,
            unsigned char   *ospvBERAlgorithm,
            unsigned        ospvBERAlgorithmLength,
            unsigned char   *ospvEncryptedData,
            unsigned        ospvEncryptedDataLength,
            unsigned char   *ospvBERReaderKey,
            unsigned        ospvBERReaderKeyLength,
            unsigned char   ospvFlags);

    int 
    OSPPCryptoWrapVerify(
            unsigned char   *ospvData,
            unsigned        ospvDataLength,
            unsigned char   *ospvSignature,
            unsigned        ospvSignatureLength,
            unsigned char   *ospvReaderKey,
            unsigned        ospvReaderKeyLength,
            unsigned char   ospvFlags);


#ifdef __cplusplus
}
#endif

