/*
*########################################################################
*########################################################################
*########################################################################
*                                                               
*   COPYRIGHT (c) 1998, 1999 by TransNexus, LLC                          
*                                                                    
*   This software contains proprietary and confidential information  
*   of TransNexus, LLC. Except as may be set forth in the license    
*   agreement under which this software is supplied, use, disclosure, 
*   or reproduction is prohibited without the prior, express, written
*   consent of TransNexus, LLC.                                      
*                                     
*
*
*
*
*
*
*#########################################################################
*#########################################################################
*#########################################################################
*/


/*
 * ospmsgattr.h - Definitions for OSP message attributes.
 */

#ifndef _OSPMSGATTR_H
#define _OSPMSGATTR_H

#include "ospmsgdesc.h"
#include "ospmsgpart.h"

/* attributes defined by the Open Settlement Protocol */

typedef enum
{
    ospeAttrUnknown = OSPC_MSGPARTUNKNOWN,
    ospeAttrComponentId,
    ospeAttrCritical,
    ospeAttrEncoding,
    ospeAttrMessageId,
    ospeAttrType,
    ospeAttrVersion,
    ospeAttrRandom
}
OSPTMSGATTRPART;

/**/
/*-----------------------------------------------------------------------*
 * externally declared global variables
 *-----------------------------------------------------------------------*/

extern const OSPTMSGDESC OSPVAttrDescs[];
extern const unsigned    OSPVNumAttrDesc;

/**/
/*-----------------------------------------------------------------------*
 * macros that emulate functions
 *-----------------------------------------------------------------------*/

#ifndef OSPC_DEBUG
/*
 * Note: all macros are also implemented as functions in ospmsgattr.c.
 * For implementation details, see the comments in that file. To replace
 * a macro with a true function, simply comment out the macro definition
 * below.
 */

#define OSPPMsgGetAttrName(ospvPart) \
    OSPPMsgDescGetName((OSPTMSGPART)(ospvPart), OSPVAttrDescs, \
                       OSPVNumAttrDesc)
#define OSPPMsgGetAttrPart(ospvName) \
   ((OSPTMSGATTRPART) OSPPMsgDescGetPart((ospvName), OSPVAttrDescs, \
                          OSPVNumAttrDesc))

#endif /* OSPC_DEBUG */

/**/
/*-----------------------------------------------------------------------*
 * function prototypes
 *-----------------------------------------------------------------------*/
#ifdef OSPC_DEBUG

const char *OSPPMsgGetAttrName(OSPTMSGATTRPART);
OSPTMSGATTRPART OSPPMsgGetAttrPart(const char *);

#endif /* OSPC_DEBUG */

#endif /* _OSPMSGATTR_H */

