/*
*########################################################################
*########################################################################
*########################################################################
*                                                               
*   COPYRIGHT (c) 1998, 1999 by TransNexus, LLC                          
*                                                                    
*   This software contains proprietary and confidential information  
*   of TransNexus, LLC. Except as may be set forth in the license    
*   agreement under which this software is supplied, use, disclosure, 
*   or reproduction is prohibited without the prior, express, written
*   consent of TransNexus, LLC.                                      
*                                     
*
*
*
*
*
*
*#########################################################################
*#########################################################################
*#########################################################################
*/


#ifndef _OSPMSGINFO_H
#define _OSPMSGINFO_H

#include "osp.h"

/*-------------------------------------------*/
/* message info typedef                      */
/*-------------------------------------------*/ 
typedef struct _OSPTMSGINFO 
{
    OSPTLISTLINK        Link;
    unsigned char       *RequestMsg;
    unsigned char       *ResponseMsg;
    unsigned char       *ContentType;
    unsigned            RequestSz;
    unsigned            ResponseSz;
    unsigned            ContentSz;
    OSPTMUTEX           Mutex;
    OSPTCONDVAR         CondVar;
    int                 ErrorCode;
    unsigned char       Flags;
} OSPTMSGINFO;

#define OSPC_MSGINFO_AUDIT_TYPE 0x01    /* bit 1 - Message type flag */

#ifdef __cplusplus
extern "C" 
{
#endif

    int  OSPPMsgInfoNew(OSPTMSGINFO **);
    void OSPPMsgInfoDelete(OSPTMSGINFO **);
    int  OSPPMsgInfoWaitForMsg(OSPTMSGINFO *);
    int  OSPPMsgInfoProcessResponse(OSPTMSGINFO *);
    void OSPPMsgInfoAssignRequestMsg(OSPTMSGINFO *, unsigned char *, unsigned);

#ifdef __cplusplus
}
#endif

#endif
