/*
*########################################################################
*########################################################################
*########################################################################
*                                                               
*   COPYRIGHT (c) 1998, 1999 by TransNexus, LLC                          
*                                                                    
*   This software contains proprietary and confidential information  
*   of TransNexus, LLC. Except as may be set forth in the license    
*   agreement under which this software is supplied, use, disclosure, 
*   or reproduction is prohibited without the prior, express, written
*   consent of TransNexus, LLC.                                      
*                                     
*
*
*
*
*
*
*#########################################################################
*#########################################################################
*#########################################################################
*/


/*
 * ospmsgque.h - Structures and prototypes for message queue object.
 */
#ifndef _OSPMSGQUE_H
#define _OSPMSGQUE_H

#include "osp.h"
#include "ospmsginfo.h"

#define OSPPMsgQueueGetCondVar(ospvMsgQueue)   (ospvMsgQueue)->CondVar

/*-------------------------------------------*/
/* message queue typedef                     */
/*-------------------------------------------*/ 
typedef struct _OSPTMSGQUEUE
{
    unsigned            NumberOfTransactions;
    OSPTMUTEX           Mutex;
    OSPTCONDVAR         CondVar;
    OSPTMSGINFO         *MsgInfoList;
} OSPTMSGQUEUE;

#ifdef __cplusplus
extern "C" 
{
#endif

    int  OSPPMsgQueueNew(OSPTMSGQUEUE **);
    void OSPPMsgQueueDelete(OSPTMSGQUEUE **);
    int  OSPPMsgQueueAddTransaction(OSPTMSGQUEUE *, OSPTMSGINFO *);
    void OSPPMsgQueueIncrementNumberOfTransactions(OSPTMSGQUEUE *);
    void OSPPMsgQueueDecrementNumberOfTransactions(OSPTMSGQUEUE *);

#ifdef __cplusplus
}
#endif

#endif
