/*
*########################################################################
*########################################################################
*########################################################################
*                                                               
*   COPYRIGHT (c) 1998, 1999 by TransNexus, LLC                          
*                                                                    
*   This software contains proprietary and confidential information  
*   of TransNexus, LLC. Except as may be set forth in the license    
*   agreement under which this software is supplied, use, disclosure, 
*   or reproduction is prohibited without the prior, express, written
*   consent of TransNexus, LLC.                                      
*                                     
*
*
*
*
*
*
*#########################################################################
*#########################################################################
*#########################################################################
*/


/*
 * osposincl.h - OS common includes.
 */
#ifndef _OSP_OS_H
#define _OSP_OS_H

/* OS common headers */
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <time.h>
#include <sys/time.h>     /* wbr added */
#include <memory.h>
#include <errno.h>
#include <assert.h>
#include <ctype.h>
#if defined(sun)
#define exception __exception
#endif
#include <math.h>
#undef exception
#include <float.h>
#include <limits.h>

#ifdef _WIN32

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <io.h>
#include <winsock.h>
#include <process.h>

#else /* UNIX */

#include <unistd.h>
#include <sys/signal.h>

#ifndef _POSIX_THREADS
#include <synch.h>
#include <thread.h>
#else
#include <pthread.h>
#endif

#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <arpa/inet.h>
#include <string.h>
#include <fcntl.h>
#endif

#endif
