/*
*########################################################################
*########################################################################
*########################################################################
*                                                               
*   COPYRIGHT (c) 1998, 1999 by TransNexus, LLC                          
*                                                                    
*   This software contains proprietary and confidential information  
*   of TransNexus, LLC. Except as may be set forth in the license    
*   agreement under which this software is supplied, use, disclosure, 
*   or reproduction is prohibited without the prior, express, written
*   consent of TransNexus, LLC.                                      
*                                     
*
*
*
*
*
*
*#########################################################################
*#########################################################################
*#########################################################################
*/


/*
 * ospostime.h - OS-specific time structures and prototypes
 */

#ifndef _OSPOSTIME_H
#define _OSPOSTIME_H

#include "time.h"

#include "osp.h"


/* time limits */

#define OSPC_TIMEMIN    ((OSPTTIME)0)
#define OSPC_TIMEMAX ((OSPTTIME)LONG_MAX)


/* OSP string time format is YYYY-MM-DDThh:mm:ssZ */

#define OSPC_TIMESTRINGSIZE (sizeof("YYYY-MM-DDThh:mm:ssZ") + 1)

/**/
/*-----------------------------------------------------------------------*
 * Function prototypes
 *-----------------------------------------------------------------------*/


#ifdef __cplusplus
extern "C" 
{
#endif

    unsigned OSPPOSTimeCalToString(OSPTTIME, char *);
    unsigned OSPPOSTimeStringToCal(const char *, OSPTTIME *);

    int
    OSPPOSTimeGetTime(
        OSPTTIME *ospvTime,
        unsigned int *ospvTimeMS);

    int
    OSPPOSTimeFormatGMTTime(
        OSPTTIME ospvTime,
        char *ospvFormat,
        char *ospvTimeString);


#ifdef __cplusplus
}
#endif



#endif

