/*
*########################################################################
*########################################################################
*########################################################################
*                                                               
*   COPYRIGHT (c) 1998 by TransNexus, LLC                          
*                                                                    
*   This software contains proprietary and confidential information  
*   of TransNexus, LLC. Except as may be set forth in the license    
*   agreement under which this software is supplied, use, disclosure, 
*   or reproduction is prohibited without the prior, express, written
*   consent of TransNexus, LLC.                                      
*                                     
*
*
*
*
*
*
*#########################################################################
*#########################################################################
*#########################################################################
*/

/*
 * osppkcs1.h - PKCS1 definitions used for key objects.
 */

#ifndef _OSP_PKCS1_H
#define _OSP_PKCS1_H

#include "osp.h"
#include "ospasn1.h"
#include "ospdatatypes.h"


#define OSPC_ASN1_PRIVATEKEYINFO_VERSION 0

#ifdef __cplusplus
extern "C" 
{
#endif

    int
    OSPPPKCS1PrivateKeyDelete(
        OSPTPRIVATEKEY **ospvPrivateKey);

    int
    OSPPPKCS1PrivateKeyCreate(
        OSPTPRIVATEKEY *ospvSourcePrivateKey,
        OSPTPRIVATEKEY **ospvNewPrivateKey);

    int
    OSPPPKCS1PrivateKeyCopy(
        OSPTPRIVATEKEY *ospvDestinationPrivateKey,
        OSPTPRIVATEKEY *ospvSourcePrivateKey);

    int
    OSPPPKCS1PrivateKeyTestContext(
        OSPTPRIVATEKEY *ospvPrivateKey);

    int
    OSPPPKCS1Encrypt(
        OSPTASN1OBJECT **ospvEncryptedDigest,
        OSPTASN1OBJECT *ospvAlgorithmId,
        OSPTASN1OBJECT *ospvDigestInfo,
        OSPTPRIVATEKEY *ospvPrivateKey);

#ifdef __cplusplus
}
#endif


#endif
