/*
*########################################################################
*########################################################################
*########################################################################
*                                                               
*   COPYRIGHT (c) 1998, 1999 by TransNexus, LLC                          
*                                                                    
*   This software contains proprietary and confidential information  
*   of TransNexus, LLC. Except as may be set forth in the license    
*   agreement under which this software is supplied, use, disclosure, 
*   or reproduction is prohibited without the prior, express, written
*   consent of TransNexus, LLC.                                      
*                                     
*
*
*
*
*
*
*#########################################################################
*#########################################################################
*#########################################################################
*/

/*
 * osppkcs8.h - PKCS8 definitions used for key objects.
 */

#ifndef _OSP_PKCS8_H
#define _OSP_PKCS8_H

#include "osp.h"
#include "ospasn1.h"
#include "ospdatatypes.h"


#define OSPC_PKCS8_PRIVATEKEYINFO_VERSION 0

#ifdef __cplusplus
extern "C" 
{
#endif
    int
    OSPPPKCS8KeyInfoCreate(
        OSPTASN1OBJECT **ospvPrivateKeyInfo,
        OSPTPRIVATEKEY *ospvPrivateKey);

    int
    OSPPPKCS8KeyInfoTestContext(
        OSPTASN1OBJECT  *ospvPrivateKeyInfo);

    void 
    OSPPPKCS8KeyInfoDelete(
        OSPTASN1OBJECT  **ospvPrivateKeyInfo);

    int
    OSPPPKCS8KeyInfoGetPrivateKey(
        OSPTASN1OBJECT *ospvPrivateKeyInfo,
        unsigned char **ospvPrivateKey,
        unsigned      *ospvPrivateKeyLength);

    int
    OSPPPKCS8KeyInfoGetPrivateKeyElement(
        OSPTASN1OBJECT *ospvPrivateKeyInfo, 
        OSPEASN1DATAREFID ospvDataRefId,
        OSPTASN1ELEMENTINFO **ospvElementInfo);

    int
    OSPPKCS8KeyInfoGetEncodedKeyInfo(
        OSPTASN1OBJECT *ospvPrivateKeyInfo,
        unsigned char **ospvBERPrivateKeyInfo,
        unsigned      *ospvBERPrivateKeyInfoLength);

#ifdef __cplusplus
}
#endif


#endif
