/*
*########################################################################
*########################################################################
*########################################################################
*                                                               
*   COPYRIGHT (c) 1998, 1999 by TransNexus, LLC                          
*                                                                    
*   This software contains proprietary and confidential information  
*   of TransNexus, LLC. Except as may be set forth in the license    
*   agreement under which this software is supplied, use, disclosure, 
*   or reproduction is prohibited without the prior, express, written
*   consent of TransNexus, LLC.                                      
*                                     
*
*
*
*
*
*
*#########################################################################
*#########################################################################
*#########################################################################
*/


/*
 * ospsocket.h - Prototypes for socket functions.
 */
#ifndef _OSP_SOCKET_H
#define _OSP_SOCKET_H

#include "ospdatatypes.h"
#include "ospcomm.h"
#include "osphttp.h"

#ifdef _WIN32
#  define OSPC_SOCK_INVALID              SOCKET_ERROR
#else
#  define OSPC_SOCK_INVALID              -1
#endif

#ifdef __cplusplus
extern "C" 
{
#endif

    int  OSPPSockClose(OSPTBOOL, OSPTSOCKET *, OSPTSSLSESSION  **);
    int  OSPPSockConnect(OSPTSOCKET *, OSPTBOOL, OSPTIPADDR, unsigned short,
            struct timeval *, OSPTSSLSESSION **);
    int  OSPPSockConnectAuditURL(OSPTHTTP  *,  OSPTBOOL *);
    int  OSPPSockConnectServicePoint(OSPTHTTP  *, OSPTBOOL *, OSPTBOOL *);
    int  OSPPSockDisableNagle(OSPTHTTP *);
    int  OSPPSockGetHostIP(char *, OSPTIPADDR *);
    int  OSPPSockNew(OSPTHTTP *);

    void OSPPSockProcessRequest(OSPTHTTP *, unsigned char *, unsigned,
             unsigned char **, unsigned *, unsigned char **, unsigned *, int *);
    int  OSPPSockRead(OSPTHTTP *, unsigned char *, unsigned int *);
    int  OSPPSockSetBlockingIO(OSPTSOCKET, OSPTBOOL);
    int  OSPPSockSetKeepAlive(OSPTHTTP *);
    int  OSPPSockWaitTillReady(OSPTSOCKET, OSPTBOOL, struct timeval *);
    int  OSPPSockWrite(OSPTHTTP *, unsigned char *, unsigned int *);

#ifdef __cplusplus
}
#endif

#endif

