/*
*########################################################################
*########################################################################
*########################################################################
*                                                               
*   COPYRIGHT (c) 1998, 1999 by TransNexus, LLC                          
*                                                                    
*   This software contains proprietary and confidential information  
*   of TransNexus, LLC. Except as may be set forth in the license    
*   agreement under which this software is supplied, use, disclosure, 
*   or reproduction is prohibited without the prior, express, written
*   consent of TransNexus, LLC.                                      
*                                     
*
*
*
*
*
*
*#########################################################################
*#########################################################################
*#########################################################################
*/


/*
 * ospstatistics.h - Statistics elements.
 */
#ifndef _OSPSTATISTICS_H
#define _OSPSTATISTICS_H

#include "osp.h"

/* Basic structure for TN statistics */
typedef struct
{
    OSPTBOOL        ospmHasSentStats;
    unsigned        ospmLossPacketsSent;
    unsigned        ospmLossFractionSent;
    OSPTBOOL        ospmHasReceivedStats;
    unsigned        ospmLossPacketsReceived;
    unsigned        ospmLossFractionReceived;
    OSPTBOOL        ospmHasOneWay;
    OSPTDELAY       ospmOneWay;
    OSPTBOOL        ospmHasRoundTrip;
    OSPTDELAY       ospmRoundTrip;
}OSPTSTATISTICS;

#ifdef __cplusplus
extern "C" 
{
#endif
    /* Function Prototypes */

    void            OSPPStatisticsDelete(OSPTSTATISTICS **);

    signed          OSPPStatisticsGetFracReceived(OSPTSTATISTICS  *);
    signed          OSPPStatisticsGetFracSent(OSPTSTATISTICS  *);
    unsigned        OSPPStatisticsGetOneWayMinimum(OSPTSTATISTICS  *);
    unsigned        OSPPStatisticsGetOneWayMean(OSPTSTATISTICS  *);
    unsigned        OSPPStatisticsGetOneWaySamples(OSPTSTATISTICS  *);
    float           OSPPStatisticsGetOneWayVariance(OSPTSTATISTICS  *);
    unsigned        OSPPStatisticsGetPktReceived(OSPTSTATISTICS  *);
    unsigned        OSPPStatisticsGetPktSent(OSPTSTATISTICS  *);
    unsigned        OSPPStatisticsGetRoundTripMinimum(OSPTSTATISTICS  *);
    unsigned        OSPPStatisticsGetRoundTripMean(OSPTSTATISTICS  *);
    unsigned        OSPPStatisticsGetRoundTripSamples(OSPTSTATISTICS  *);
    float           OSPPStatisticsGetRoundTripVariance(OSPTSTATISTICS  *);

    OSPTBOOL        OSPPStatisticsHasLossReceived(OSPTSTATISTICS *);
    OSPTBOOL        OSPPStatisticsHasLossSent(OSPTSTATISTICS *);
    OSPTBOOL        OSPPStatisticsHasOneWay(OSPTSTATISTICS *);
    OSPTBOOL        OSPPStatisticsHasRoundTrip(OSPTSTATISTICS *);

    int             OSPPStatisticsLossReceivedToElement(OSPTSTATISTICS *, 
                                                        OSPTXMLELEM    **);
    int             OSPPStatisticsLossSentToElement(OSPTSTATISTICS *, 
                                                    OSPTXMLELEM    **);

    OSPTSTATISTICS  *OSPPStatisticsNew(void);

    int             OSPPStatisticsOneWayToElement(OSPTSTATISTICS  *,
                                                  OSPTXMLELEM     **);
    int             OSPPStatisticsRoundTripToElement(OSPTSTATISTICS  *,
                                                    OSPTXMLELEM     **);
    int             OSPPStatisticsReportUsage(OSPTSTATISTICS **, unsigned, 
                                              signed, unsigned, signed);

    void            OSPPStatisticsSetReceivedStatistics(OSPTSTATISTICS *,
                                                   unsigned, signed);

    void            OSPPStatisticsSetSentStatistics(OSPTSTATISTICS *,
                                                   unsigned, signed);
    int             OSPPStatisticsToElement(OSPTSTATISTICS  *,
                                            OSPTXMLELEM     **);

#ifdef __cplusplus
}
#endif

#endif


