/*
*########################################################################
*########################################################################
*########################################################################
*                                                               
*   COPYRIGHT (c) 1998, 1999 by TransNexus, LLC                          
*                                                                    
*   This software contains proprietary and confidential information  
*   of TransNexus, LLC. Except as may be set forth in the license    
*   agreement under which this software is supplied, use, disclosure, 
*   or reproduction is prohibited without the prior, express, written
*   consent of TransNexus, LLC.                                      
*                                     
*
*
*
*
*
*
*#########################################################################
*#########################################################################
*#########################################################################
*/


/*
 * osptnaudit.h - TNAudit elements.
 */
#ifndef _OSPTNAUDIT_H
#define _OSPTNAUDIT_H

#include "osp.h"

typedef struct
{
    unsigned          ospmAuditState;
    unsigned char     *ospmAuditURL;
    unsigned          ospmAuditTimeLimit;
    unsigned          ospmAuditMaxMessages;
}
OSPTTNAUDIT;


/* Function prototypes */
#ifdef __cplusplus
extern "C" 
{
#endif
    void           OSPPTNAuditDelete(OSPTTNAUDIT **ospvTNAudit);
    int            OSPPTNAuditFromElement(OSPTXMLELEM *, OSPTTNAUDIT **);

    unsigned            OSPPTNAuditGetMaxMessages(OSPTTNAUDIT *);
    OSPE_AUDIT_STATE    OSPPTNAuditGetState(OSPTTNAUDIT *);
    unsigned            OSPPTNAuditGetTimeLimit(OSPTTNAUDIT *);
    unsigned char       *OSPPTNAuditGetURL(OSPTTNAUDIT *);
    
    unsigned       OSPPTNAuditHasMaxMessages(OSPTTNAUDIT *);
    unsigned       OSPPTNAuditHasState(OSPTTNAUDIT *);
    unsigned       OSPPTNAuditHasTimeLimit(OSPTTNAUDIT *);
    unsigned       OSPPTNAuditHasURL(OSPTTNAUDIT *);

    OSPTTNAUDIT    *OSPPTNAuditNew(void);

    void           OSPPTNAuditSetMaxMessages(OSPTTNAUDIT *, unsigned);
    void           OSPPTNAuditSetState(OSPTTNAUDIT *, OSPE_AUDIT_STATE);
    void           OSPPTNAuditSetTimeLimit(OSPTTNAUDIT *, unsigned);
    void           OSPPTNAuditSetURL(OSPTTNAUDIT *, unsigned char *);

#ifdef __cplusplus
}
#endif

#endif
