/*
*########################################################################
*########################################################################
*########################################################################
*                                                               
*   COPYRIGHT (c) 1998, 1999 by TransNexus, LLC                          
*                                                                    
*   This software contains proprietary and confidential information  
*   of TransNexus, LLC. Except as may be set forth in the license    
*   agreement under which this software is supplied, use, disclosure, 
*   or reproduction is prohibited without the prior, express, written
*   consent of TransNexus, LLC.                                      
*                                     
*
*
*
*
*
*
*#########################################################################
*#########################################################################
*#########################################################################
*/

/*
 * osptransapi.h - Prototypes for transaction object API functions.
 */
#ifndef _OSPTRANSAPI_H
#define _OSPTRANSAPI_H

#include "ospfail.h"

/* Authorisation Indicators */
#define OSPC_TRAN_AUTHORISED        0x0001
#define OSPC_TRAN_REAUTHORISED      0x0002
#define OSPC_TRAN_NOT_AUTHORISED    0xefff

#ifdef __cplusplus
extern "C" 
{
#endif

    /* Function Prototypes */

    int OSPPTransactionAccumulateOneWayDelay(OSPTTRANHANDLE, unsigned, 
            unsigned, unsigned, float);

    int OSPPTransactionAccumulateRoundTripDelay(OSPTTRANHANDLE, unsigned, 
            unsigned, unsigned, float);

    int OSPPTransactionDelete(OSPTTRANHANDLE);

    int OSPPTransactionGetFirstDestination(OSPTTRANHANDLE, unsigned, char *,
            char *, unsigned *, unsigned *, void *, unsigned, char *,
            unsigned, char *, unsigned, char *,unsigned *, void *);

    int OSPPTransactionGetNextDestination(OSPTTRANHANDLE, enum OSPEFAILREASON,
            unsigned, char *, char *, unsigned *, unsigned *, void *, unsigned,
            char *, unsigned, char *, unsigned, char *, unsigned *, void *);

    int OSPPTransactionInitializeAtDevice(OSPTTRANHANDLE, unsigned, const char *,
            const char *, const char *, const char *,const char *,const char *,
            unsigned, const void *, unsigned, const void *,unsigned *,unsigned *,
            unsigned *, void *);

    int OSPPTransactionNew(OSPTPROVHANDLE, OSPTTRANHANDLE *);

    int OSPPTransactionRecordFailure(OSPTTRANHANDLE, enum OSPEFAILREASON);

    int OSPPTransactionReinitializeAtDevice(OSPTTRANHANDLE, enum OSPEFAILREASON,
            unsigned, const char *, const char *, const char *, const char *,
            const char *, const char *, unsigned, const void *, unsigned,
            const void *, unsigned *, unsigned *, unsigned *, void *);

    int OSPPTransactionReportUsage(OSPTTRANHANDLE, unsigned, unsigned, signed,
            unsigned, signed, unsigned *, void *);

    int OSPPTransactionRequestAuthorisation(OSPTTRANHANDLE, const char *, 
            const char *, const char *, const char *, const char *, 
            unsigned, OSPTCALLID *[], const char *[], unsigned *, unsigned *, 
            void *);

    int OSPPTransactionRequestReauthorisation(OSPTTRANHANDLE, unsigned, unsigned *,           
            void *, unsigned *,unsigned *,unsigned *, void *);

    int OSPPTransactionValidateAuthorisation(OSPTTRANHANDLE, const char *,
            const char *, const char *, const char *, const char *, 
            const char *, unsigned, const void *, unsigned, const void *, 
            unsigned *, unsigned *, unsigned *, void *);

    int OSPPTransactionValidateReAuthorisation(OSPTTRANHANDLE, unsigned, const void *,                 
            unsigned *, unsigned *, unsigned *, void *);            
#ifdef __cplusplus
}
#endif

#endif

