/*
*########################################################################
*########################################################################
*########################################################################
*                                                               
*   COPYRIGHT (c) 1998, 1999 by TransNexus, LLC                          
*                                                                    
*   This software contains proprietary and confidential information  
*   of TransNexus, LLC. Except as may be set forth in the license    
*   agreement under which this software is supplied, use, disclosure, 
*   or reproduction is prohibited without the prior, express, written
*   consent of TransNexus, LLC.                                      
*                                     
*
*
*
*
*
*
*#########################################################################
*#########################################################################
*#########################################################################
*/

/*
 * ospusagecnf.h - OSP Usage Confirm Objects
 */

#ifndef _OSPUSAGECNF_H
#define _OSPUSAGECNF_H

#include "osp.h"
#include "ospxmlelem.h"
#include "ospmsg.h"
#include "ospstatus.h"
#include "osptnaudit.h"
#include "ospciscoext.h"


typedef struct
{
    OSPTLISTLINK    ospmUsageCnfLink;
    OSPTTIME        ospmUsageCnfTimestamp;
    unsigned char   *ospmUsageCnfMessageId;
    unsigned char   *ospmUsageCnfComponentId;
    OSPTSTATUS      *ospmUsageCnfStatus;
    OSPTTNAUDIT     *ospmUsageCnfTNAudit;
    OSPTCSAUDIT     *ospmUsageCnfCSAudit;
}
OSPTUSAGECNF;


/**/
/*-----------------------------------------------------------------------*
 * macros that emulate functions
 *-----------------------------------------------------------------------*/

/*
 * Note: all macros are also implemented as functions in ospusageind.c.
 * For implementation details, see the comments in that file. To replace
 * a macro with a true function, simply comment out the macro definition
 * below.
 */

#ifndef OSPC_DEBUG
/* Timestamp */
#define OSPPUsageCnfSetTimestamp(ospvUsageCnf,ospvTime) \
    (ospvUsageCnf)->ospmUsageCnfTimestamp = (ospvTime)

/* Status */
#define OSPPUsageCnfHasStatus(ospvUsageCnf) \
    (ospvUsageCnf)?((ospvUsageCnf)->ospmUsageCnfStatus != OSPC_OSNULL):OSPC_FALSE
#define OSPPUsageCnfGetStatus(ospvUsageCnf) (ospvUsageCnf)->ospmUsageCnfStatus


#endif /* OSPC_DEBUG */

#ifdef __cplusplus
extern "C" 
{
#endif

    /**/
    /*-----------------------------------------------------------------------*
     * function prototypes
     *-----------------------------------------------------------------------*/

    OSPTUSAGECNF   *OSPPUsageCnfNew(void);
    unsigned        OSPPUsageCnfFromElement(OSPTXMLELEM *, OSPTLIST *);
    void            OSPPUsageCnfDelete(OSPTUSAGECNF **);

    unsigned char  *OSPPUsageCnfGetComponentId(OSPTUSAGECNF *);
    unsigned        OSPPUsageCnfHasComponentId(OSPTUSAGECNF *);
    void            OSPPUsageCnfSetComponentId(OSPTUSAGECNF  *, unsigned char *);

    void            OSPPUsageCnfComponentIdFromElement(OSPTXMLELEM *, const unsigned char **);

    void           OSPPUsageCnfMessageIdFromElement(OSPTXMLELEM *, unsigned char **);

    unsigned       OSPPUsageCnfHasMessageId(OSPTUSAGECNF *);
    void           OSPPUsageCnfSetMessageId(OSPTUSAGECNF *, unsigned char *);

#ifdef OSPC_DEBUG
    void          OSPPUsageCnfSetTimestamp(OSPTUSAGECNF *, OSPTTIME);

    unsigned     OSPPUsageCnfHasStatus(OSPTUSAGECNF *ospvUsageCnf);

    OSPTSTATUS  *OSPPUsageCnfGetStatus(OSPTUSAGECNF *);

#endif /* OSPC_DEBUG */

    OSPTTNAUDIT *OSPPUsageCnfGetTNAudit(OSPTUSAGECNF *);
    OSPTCSAUDIT *OSPPUsageCnfGetCSAudit(OSPTUSAGECNF *);

#ifdef __cplusplus
}
#endif

#endif /* _OSPUSAGECNF_H */
