/*
*########################################################################
*########################################################################
*########################################################################
*                                                               
*   COPYRIGHT (c) 1998, 1999 by TransNexus, LLC                          
*                                                                    
*   This software contains proprietary and confidential information  
*   of TransNexus, LLC. Except as may be set forth in the license    
*   agreement under which this software is supplied, use, disclosure, 
*   or reproduction is prohibited without the prior, express, written
*   consent of TransNexus, LLC.                                      
*                                     
*
*
*
*
*
*
*#########################################################################
*#########################################################################
*#########################################################################
*/

/*
 * ospx500.h - Constants for X500 objects.
 */

#ifndef _OSP_X500_H
#define _OSP_X500_H

#include "osp.h"
#include "ospasn1.h"

#define OSPC_DN_ELEMENT_TERMINATOR (-1)  /* Not a legal OID value */

#define OSPC_MAX_DN_ELEMENTS       10    /* Max DN elements */

#define OSPC_MAX_FIELDNAME_LENGTH  50
#define OSPC_MAX_FIELDVALUE_LENGTH 50

typedef struct {
    char fieldname[OSPC_MAX_FIELDNAME_LENGTH];
    char fieldvalue[OSPC_MAX_FIELDVALUE_LENGTH];
} OSPTDNTEXTELEMENT;

typedef struct {
    unsigned int     elementCount;
    OSPTATTRTYPEVAL *elements[OSPC_MAX_DN_ELEMENTS];
} OSPTDISTINGUISHEDNAME;

#endif
