/**************************************************************************** 
** File: udp.h
**
** Author: Mike Borella
**
** Comments: Generic UDP header structure - an attempt at OS independence
**
*****************************************************************************/

#define L2TP_PORT 1701

#define DHCP_CLIENT_PORT 68
#define DHCP_SERVER_PORT 67
#define SIP_PORT 5060
#define RIP_PORT 520
#define ISAKMP_PORT 500

extern unsigned int current_ip_src_port;
extern unsigned int current_ip_dst_port;

typedef struct _UDPHdr
{
  u_int16_t uh_src;
  u_int16_t uh_dst;
  u_int16_t uh_len;
  u_int16_t uh_chk;
} UDPHdr;

void dump_udp(u_char *, int);
